//
//  QGChainController.h
//  Immutation
//
//  Created by Matthew McCowan on 7/13/07.
//  Copyright 2007 Quickgigs, Inc. All rights reserved.
//

#import "QGFoundation.h"
#import "QGChainView.h"
#import "QGFilterBrowser.h"
#import "QGAddFilterController.h"
#import "QGFilterController.h"
#import "QGChain.h"


@interface QGChainController : QGController
{
	IBOutlet NSWindow      *window;
	NSFileManager  *fileManager;
	NSString       *companyFolder;
	NSString       *dataFolder;
	NSString       *chainFolder;
	NSMutableArray *filenames;

	// Instance
	NSMutableArray  *filterControllers;
	NSMutableArray  *addControllers;
	NSMutableArray  *inputValues;
	float            currentY;
	QGFilterBrowser *filterBrowser;
	unsigned         addIndex;
	unsigned         addFilterIndex;
	NSScrollView    *scrollView;
	
	// Outlet
	IBOutlet NSWindow      *mainWindow;
	
	IBOutlet QGChainView   *view;
	IBOutlet NSWindow      *filterBrowserWindow;
	IBOutlet NSBrowser     *browser;
	IBOutlet NSButton      *chooseButton;
	
	IBOutlet NSButton      *saveChainButton;
	IBOutlet NSTextField   *saveNameText;
	
	IBOutlet NSWindow      *chainBrowserWindow;
	IBOutlet NSBrowser     *chainBrowser;
	IBOutlet NSButton      *chooseChainButton;
}


// Initialization
- (void) clear;
- (void) initApplicationSupport;
- (void) initPath:(NSString *)path;
- (void) initChainFiles:(NSString *)path;

// Setters and Getters
//- (QGChain *) value;
//- (void) setValue:(QGChain *)newChain;
- (BOOL) hasValue;
- (unsigned) count;
- (QGChain *) chain;

// Filters
//- (void) addFilterName:(NSString *)newFilterName atIndex:(unsigned)newIndex;
//- (void) removeFilterAtIndex:(unsigned)removeIndex;


// Actions
- (IBAction) changeValue:(id)sender;
- (IBAction) userClear:(id)sender;
- (IBAction) addFilter:(id)sender;
- (CIImage *) applyToImage:(CIImage *)image withBounds:(CGRect)bounds;
- (void) changeInputValue:(NSNotification *)note;
- (void) addNewFilterIndex:(unsigned)addFilterIndex atPositionIndex:(unsigned)positionIndex;

// Browser Controls
- (int) browser:(NSBrowser *)sender numberOfRowsInColumn:(int)column;
- (void) browser:(NSBrowser *)sender willDisplayCell:(id)cell atRow:(int)row column:(int)column;
- (void) closeSheet:(id)sender;
- (void) filterSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (IBAction) choose:(id)sender;
- (IBAction) cancel:(id)sender;
- (IBAction) browserChange:(id)sender;

- (IBAction) chooseFilename:(id)sender;
- (IBAction) openChainSelectWindow:(id)sender;
- (IBAction) cancelChainSelect:(id)sender;
- (IBAction) save:(id)sender;

// Misc
- (void) layout;
- (void) removeFilter:(id)sender;
- (void) checkForPossibleSave;
- (IBAction) changeSaveText:(id)sender;
- (void)controlTextDidChange:(NSNotification *)aNotification;
@end
