//
//  QGDynamicController.h
//  Immutation
//
//  Created by Matthew McCowan on 7/19/07.
//  Copyright 2007 Quickgigs, Inc. All rights reserved.
//

#import "QGFoundation.h"
#import "FilterControl.h"

@interface QGDynamicController : QGController
{
	// Instance
	id  <FilterControl> owner;

	// Outlet
	IBOutlet QGView *view;
}

// Initialization
- (id) initWithOwner:(id)initOwner;


// Properties
- (NSString *) nibName;
- (QGView *) view;


// View Management
- (void) addToView:(QGView *)parentView withX:(float)x andMaxY:(float)y;
- (void) addToView:(QGView *)parentView withX:(float)x andY:(float)y;
- (void) removeView;
- (void) removeChildViews;   // called from removeFromView (override if needed)

// Placement
- (void) setX:(float)x;
- (void) setY:(float)y;
- (void) setX:(float)x andMaxY:(float)y;
- (void) setX:(float)x andY:(float)y;
- (float) x;
- (float) y;
- (float) width;
- (float) height;

@end
